function theta = boundsINV(param);

 
iotap=bound0BINV(param(1),.95);     
iotaw=bound0BINV(param(2),.95);     
h=bound01INV(param(3));  
Fbeta=(param(4)); % part of sd_pis
S=bound0INV(param(5));
fp=param(6); 
fy=param(7);       
fdy=param(8);      
rhoR=bound0BINV(param(9),.99);
rhoz=boundBBINV(param(10),.99);
rhog=bound0BINV(param(11),.99);
rhomiu=bound0BINV(param(12),.99);
rholambdap=bound0BINV(param(13),.99);
rholambdaw=bound0BINV(param(14),.99);
rhob=bound0BINV(param(15),.99);
rho_z=boundBBINV(param(16),.97);

sdR=bound0INV(param(17));
sdz=bound0INV(param(18)); 
sdg=bound0INV(param(19)); 
sdmiu=bound0INV(param(20));
sdlambdap=bound0INV(param(21)); 
sdlambdaw=bound0INV(param(22)); 
sdb=bound0INV(param(23));
sdPIS=bound0INV(param(24));
sdRRA=bound01INV(param(25));

ucons=bound01INV(param(26));
rs2=(param(27)); % part of sd_pis

ALPHA=bound0INV(param(28)-2);

sd_bond=(param(29));
sdd=param(30);

rhoMAp=bound01INV(param(31));
rhoMAw=bound01INV(param(32));

rhomp=(param(33)); % part of sd_pis

theta = [iotap iotaw h Fbeta...
    S fp fy fdy rhoR rhoz rhog rhomiu rholambdap rholambdaw...
    rhob rho_z sdR sdz sdg sdmiu sdlambdap...
    sdlambdaw sdb sdPIS sdRRA ...
    ucons rs2 ALPHA sd_bond sdd rhoMAp rhoMAw rhomp];



function rho = bound01INV(param);
rho = log(param/(1-param));

%%%% this was wrong in their original code...
function rho = bound0BINV(param,B);
rho = log((param/B)/(1-(param/B)));

function rho = boundBBINV(param,B);
param=(param+B)/2;
rho = log((param/B)/(1-(param/B)));

function sigma = bound0INV(param);
sigma = log(param);