

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Table 2

Y1a=-400*y(:,9)/4;
Y2a=-400*y(:,10)/8;
Y3a=-400*y(:,11)/12;
Y4a=-400*y(:,12)/16;
Y5a=-400*y(:,8)/20;
Y10a=-400*y(:,13)/40;
Y20a=-400*y(:,14)/80;
Y0a=400*y(:,7);

yields=[Y0a Y1a Y2a Y3a Y4a Y5a Y10a Y20a];

for i=2:8
    [~,~,r]=regress(yields(:,i),[yields(:,1) ones(88,1)]);
    yields(:,i)=r;
end


resids2=pcares(yields(:,2:end),1);
resids3=pcares(yields(:,2:end),2);
[100*std(resids3)
    100*std(resids2)]


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%%%% fitted yields


Y1 = 400*(-B(1,:)*x);
Y8 = 400*(-B(8,:)*x)/8;
Y12 = 400*(-B(12,:)*x)/12;
Y16 = 400*(-B(16,:)*x)/16;
Y20 = 400*(-B(20,:)*x)/20;
Y40 = 400*(-B(40,:)*x)/40;
Y80 = 400*(-B(80,:)*x)/80;
Y4 = 400*(-B(4,:)*x)/4;

Y4a=-400*y(:,9)/4;
Y8a=-400*y(:,10)/8;
Y12a=-400*y(:,11)/12;
Y16a=-400*y(:,12)/16;
Y20a=-400*y(:,8)/20;
Y40a=-400*y(:,13)/40;
Y80a=-400*y(:,14)/80;
Y1a=400*y(:,7); Y0a=Y1a;
        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% figure 2
 
err = 100*[Y4(2:end)'-Y4a, Y8(2:end)'-Y8a, Y12(2:end)'-Y12a, Y16(2:end)'-Y16a, Y20(2:end)'-Y20a, Y40(2:end)'-Y40a, Y80(2:end)'-Y80a]
 
 Y1a=-400*y(:,9)/4;
Y2a=-400*y(:,10)/8;
Y3a=-400*y(:,11)/12;
Y4a=-400*y(:,12)/16;
Y5a=-400*y(:,8)/20;
Y10a=-400*y(:,13)/40;
Y0a=400*y(:,7);

ret10=400*(-39*Y10a(2:end)/400 + 40*Y10a(1:end-1)/400 - Y0a(1:end-1)/400);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% figure 3
-400*B(1:40,:)*SS./[1:40]'+7.3427+10*B(40,:)*SS

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% figure 4

% estimate VAR in yields
X=[Y0a Y5a Y10a];
Y=X(2:end,:);
X=X(1:end-1,:);
GAM=(X'*X)\X'*Y;

ER10 = (-39)*[0,0,1]*(X*GAM)'/400 - (-40)*[0,0,1]*X'/400 - [1,0,0]*X'/400;

Y10_0 = [1,0,0]*X';
for i=1:39
    Y10_0 = Y10_0 + [1,0,0]*(X*(GAM^i))';
end
Y10_0=Y10_0/40;
% plot([Y10a(2:end) Y10_0'])
% plot([Y10a(2:end)-Y10_0'])

ER10v=ER10'*400;
TPv=Y10a(2:end)-Y10_0';
TS=Y10a-Y0a;

EY10=H(7,:)*x;
for i=1:39
    EY10=EY10+H(7,:)*(PHI^i)*x;
end
EY10=EY10/40;

TPm=400*(-y(:,13)/40 - EY10(2:end)' - C(7));
ER10m=400*(39*(H(13,:)*PHI*x(:,2:end))/40 - H(13,:)*x(:,2:end) - y(:,7)')';

[TPm(2:end) TS(2:end) ER10v ER10m(2:end)]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% figure 5
B_LEV = -400*(B(1,:)+B(20,:)/20+B(40,:)/40);
B_SLO = -400*(B(40,:)/40 - B(1,:));
B_CUR = -400*(B(20,:)/20+B(4,:)/4 - 2*B(12,:)/12);

for i=1:9
    dLEV(:,i)=B_LEV*squeeze(IRF(:,i,1:40));
    dSLO(:,i)=B_SLO*squeeze(IRF(:,i,1:40));
    dCUR(:,i)=B_CUR*squeeze(IRF(:,i,1:40));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% figure 6

SDXa=SDX; SDXa(8,2)=0;
IRF=M*SDXa;
for j=1:2000
    IRF(:,:,j+1)=G1*IRF(:,:,j);
end
    
(-400*B(1,:)*squeeze(IRF(:,4,1:40)))'
(-400*B(20,:)*squeeze(IRF(:,4,1:40)))'/20
(-400*B(40,:)*squeeze(IRF(:,4,1:40)))'/40

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% old figure 7

% % simulate a long sample
% draw=randn(9,100000);
% SIM=zeros(length(SS),100000);
% SIM(:,1)=SS;
% for i=2:100000
%     SIM(:,i)=PHI*SIM(:,i-1)+PSI*SDX*draw(:,i);
% end
% 
% dy=H(1,:)*SIM;
% dc=H(2,:)*SIM;
% for i=0:40
%     ac_dy(i+1)=corr(dy(1+i:end)',dy(1:end-i)');
%     ac_dc(i+1)=corr(dc(1+i:end)',dc(1:end-i)');
% end




%%%%%%
HJ =bsxfun(@plus, ...
                bsxfun(@times,((RHO-(1-(1-RHO)*x(23,:)'))/(1-RHO)),(G_UC+G_R)*PSI*SDX2),...
                - G_R*PSI*SDX2);
HJ=sqrt(sum(HJ.^2,2))*2;

HJss=((RHO-(1-(1-RHO)*SS(23)))/(1-RHO))*(G_UC+G_R)*PSI*SDX2- G_R*PSI*SDX2;

HJss=sqrt(sum(HJss.^2))

TS=-400*y(:,13)/40 - (-400*(-y(:,7)));

ER10=H(7,:)*x;
for i=1:39
    ER10=ER10+H(7,:)*(PHI^i)*x;
end
ER10=ER10/40;

TP=400*(-y(:,13)/40 - ER10(2:end)' - C(7));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
%%%% steady-state term structure
yb=data_bonds;
adj=[1:40]'*(mean(y(:,13))-B(40,:)*SS)/40;

%% standard errors for spreads
SEs=[0.27494337
0.25478332
0.20360919
0.15727826
0.11995679
0.08946883
0];

%% empirical values, window
yields=[4*mean(yb(93:end,7)) -400*mean(yb(93:end,[9:12 8]))./[4:4:20] -400*mean(yb(93:end,13))/40];
yields_up=yields+1.96*SEs';
yields_dn=yields-1.96*SEs';

figure
plot([1:40],-400*(adj+B*SS)./[1:40]','-*k')
hold
plot([1 4:4:20 40],yields,'+-m')
jbfill([1 4:4:20 40],yields_up,yields_dn,'k','k',1,.15)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% table 4
NY=length(G1);
G_dy = zeros(1,NY); G_dy(1)=1; G_dy(16)=1;
G_di = zeros(1,NY); G_di(12)=1; G_di(16)=1;
G_c=zeros(1,NY); G_c(9)=1; G_c(16)=1;
G_SDF=SS(36)*(G_UC-beta*betaI*G_b+G_R)-G_R;
        G_SDF=SS(23)*(G_UC+G_R)-G_R;
        
        %%% unlevered capital return
        rss=exp(RHO*gamma)/beta-1;
        delta=.025;
        Rkss=exp(rss)-1+delta;
        lambda=8;
        Rk=4;
        G_RK = zeros(1,NY); G_lam = zeros(1,NY);
        G_RK(Rk)=exp(-rss)*Rkss;  G_lam(lambda)=exp(-rss)*(1-delta);
        G_K=G_RK+G_lam;
        G_K=G_K/100;

        %%% Levered capital return
        G_p=zeros(1,NY); G_p(6)=1;
        G_Lk=zeros(1,NY);
        L=2;
        bottom=Rkss+1-delta - (1-(1/L));
        G_Lk(Rk) = Rkss/bottom;
        G_Lk(lambda) = (1-delta)/bottom;
        G_Lk = G_Lk - (1-(1/L))*B(40,:)/bottom + (1-(1/L))*G_p/bottom;
        G_Lk=G_Lk/100;


        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        %% levered utility claim

        G_Rc=zeros(1,NY); G_Rc(28)=1;
        G_p=zeros(1,NY); G_p(6)=1;

        G_Lc=zeros(1,NY);
        G_Lc = 2*G_Rc - (100*B(1,:) - G_p);
        G_Lc=G_Lc/100;

        G_Lcr=zeros(1,NY);
        G_Lcr = 2*G_Rc - 100*Br(40,:);
        G_Lcr=G_Lcr/100;
        
VD1=[G_SDF;G_R;G_Rc/100;G_Lc;G_Lcr;B(40,:)-G_p/100;G_dy;G_c;G_di]*M*SDX;
VD1=VD1.^2;
VD1=[bsxfun(@times,VD1,1./sum(VD1,2))];

VD1=[G_SDF;G_R;G_Rc/100;G_Lc;G_Lcr;B(40,:)-G_p/100;G_dy;G_c;G_di]*M*SDX;
Vcov=VD1*VD1';

VD1=VD1.^2; 
sdfcorr=Vcov(:,1)./sqrt(Vcov(1,1)*diag(Vcov));
ER=-Vcov(:,1)*400;

VD1=[bsxfun(@times,VD1,1./sum(VD1,2))];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% table 5
UC = 40;
aa=((1-ALPHA)/(1-RHO))*G_UC*PSI*SDX2 +  ((RHO-ALPHA)/(1-RHO))*G_R*PSI*SDX2;

% UC innovation
bb = (G_UC*PSI*SDX2);

% sum of dU innovation
IRF2=IRF; 
IRF2(:,:,2:end)=IRF(:,:,1:end-1); IRF2(:,:,1)=0;
cc = sum(bsxfun(@times,permute(beta.^[0:2000],[3,1,2]),IRF(39,:,:)-IRF2(39,:,:)),3);
cc(2)=cc(2)+(IRF(15,2,1)+IRF(15,2,2))*(1-RHO);

% remainder
dd = aa - bb - ((1-ALPHA)/(1-RHO))*cc;

[aa' bb' ((1-ALPHA)/(1-RHO))*cc' dd']


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % old stuff; don't use
% 
% %% figure 2
% [-400*(adj+B*SS)./[1:40]']
% [[1 4:4:20 40]',yields',yields_up',yields_dn']
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
% %% figure 3. technology IRF
% NN=NY;
% IRF=zeros(NN,100);
% EPS=zeros(9,1); EPS(2)=SDX(2,2);
% IRF(:,1)=zeros(NN,1);
% IRF(:,2)=M*EPS;
% for i=3:100
%     IRF(:,i)=G1*IRF(:,i-1);
% end
% 
% % R, pi*, pi, ygap
% z_cum=cumsum(IRF(16,:));
% IRFa=[4*IRF(10,:)' 4*IRF(35,:)' 4*IRF(6,:)' IRF(15,:)'-IRF(56,:)'...
%     -400*(Br(1,:)*IRF)' IRF(15,:)'+z_cum' IRF(9,:)'+z_cum'];
% IRFa(1:21,:)
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%55
% %% figure 3. RRA IRF
% NN=NY;
% IRF=zeros(NN,100);
% EPS=zeros(9,1); EPS(7)=SDX(7,7);
% IRF(:,1)=zeros(NN,1);
% IRF(:,2)=M*EPS;
% for i=3:100
%     IRF(:,i)=G1*IRF(:,i-1);
% end
% 
% % R, pi*, pi, ygap, rf_real, y
% z_cum=cumsum(IRF(16,:));
% IRFa=[4*IRF(10,:)' 4*IRF(35,:)' 4*IRF(6,:)' IRF(15,:)'-IRF(56,:)'...
%     -400*(Br(1,:)*IRF)' IRF(15,:)'+z_cum' IRF(9,:)'+z_cum'];
% IRFa(1:21,:)
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% %% figure 4
% %% get the variances for the reduced-form shocks (ignoring correlations)
% sdR=param(29); sdz=param(30); sdg=param(31); sdmiu=param(32); sdlambdap=param(33); sdlambdaw=param(34); sdb=param(35);
% 
% sd_PIS=param(36);
% 
% sd_Z=param(44)/(1-RHO);
% Z_bar=(1-ALPHA)/(1-RHO);
% rho_Z=param(46)^.25;
%               
% V_pis=sd_PIS^2;
% shrs=(-1+2*param(37:43)).^2;
% % shrs(1)=0;
% ks=sqrt(shrs*V_pis./([sdR sdz sdg sdmiu sdlambdap sdlambdaw sdb].^2));
% ks=ks.*sign(-1+2*param(37:43));
% pis_resp=ks; pis_resp=[pis_resp 0 0];
% pis_resp(end-1)=sqrt(max(0,V_pis - sum((pis_resp(1:end-2).^2).*([sdR sdz sdg sdmiu sdlambdap sdlambdaw sdb].^2))));
% 
% %%%%
% 
% V_Z=(sd_Z^2)*(1-rho_Z^2);
% shrs=(-1      +2*[.5 param(45)  .5 .5     .5       .5    .5]).^2;
% ks=sqrt(shrs*V_Z./([sdR sdz sdg sdmiu sdlambdap sdlambdaw sdb].^2));
% ks=ks.*sign(-1+2*[.5 param(45)  .5 .5     .5       .5    .5]);
% Z_resp=ks; Z_resp=[Z_resp 0 0];
% Z_resp(end)=sqrt(max(0,V_Z - sum((Z_resp(1:end-2).^2).*([sdR sdz sdg sdmiu sdlambdap sdlambdaw sdb].^2))));
% 
% %% pis_resp gives the increase in pi* for a unit shock to each eps.
% %% so if we raise mp by SDX(1,1), we want to lower pi* by
% %% pis_resp(1)*SDX(1,1). However, to do that, you need to raise 
% %% eps(8) by pis_resp(1)*SDX(1,1)/pis_resp(8)
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%     
% NN=75;
% Bfac=zeros(1,NN);
% Bfac(1,:)=400*(-B(1,:) + (-B(20,:)/20) + (-B(40,:)/40))/3;
% Bfac(2,:)=400*((-B(40,:)/40) - (-B(1,:)));
% Bfac(3,:)=400*((-B(20,:)/20) - 2*(-B(12,:)/12) + (-B(4,:)/4));
% 
% IRFB=zeros(100,3,9);
% for shock=1:9
%     IRF=zeros(NN,100);
%     EPS=zeros(9,1); EPS(shock)=SDX(shock,shock);
%              if shock~=8; EPS(8)=-pis_resp(shock)*SDX(shock,shock)/pis_resp(8); end
%     IRF(:,1)=zeros(NN,1);
%     IRF(:,2)=M*EPS;
%     for i=3:100
%         IRF(:,i)=G1*IRF(:,i-1);
%     end
% 
%     IRFB(:,:,shock)=(Bfac*IRF)';
% end
% 
% 
% IRFB=permute(IRFB,[1,3,2]);
% IRFB(:,end,:)=-IRFB(:,end,:);
% IRFB(1:40,:,:)
% 
% % responses of bonds to the shocks
% 
% % plot(-[[B(1,:); B(20,:)/20; B(40,:)/40]*IRF]')
% % 
% % plot((1-rhoR)*fp*IRF(p,2:end) + ...
% %         ((1-rhoR)*fy+fdy)*IRF(gdp,2:end) + ...
% %         -((1-rhoR)*fy+fdy)*IRF(gdpstar,2:end) + ...
% %         - fdy*IRF(gdp,1:end-1) + ...
% %         fdy*IRF(gdpstar,1:end-1) + ...
% %         rhoR*IRF(R,1:end-1))
% %         
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
% %% Figure 4
% 
%         Y1 = 400*(-B(1,:)*x);
%         Y8 = 400*(-B(8,:)*x)/8;
%         Y12 = 400*(-B(12,:)*x)/12;
%         Y16 = 400*(-B(16,:)*x)/16;
%         Y24 = 400*(-B(20,:)*x)/20;
%         Y20 = 400*(-B(24,:)*x)/24;
%         Y40 = 400*(-B(40,:)*x)/40;
%         Y4 = 400*(-B(4,:)*x)/4;
% %% figure 5
% CP = -12*Y24 + 10*Y20 + 16*Y16 - 12*Y12 - 4*Y8 + 2*Y4;
% [TP(93:end)' TS(93:end) CP(93:end)']
% 
% 
% %% figure 3
% [ 4*x(35,93:end)' 4*y(93:end,6) (Y1(93:end)'+Y20(93:end)'+Y40(93:end)')/3]
% 
% Gc=zeros(1,NN);
% Gc(9)=1; Gc(16)=1;
% %% correlation of dc w/ the SDF
% (Gc*PSI_*(s0+sz*Zbar)')/sqrt(sum((Gc*PSI_).^2)*sum((s0+sz*Zbar).^2))
% 
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %% expected returns
% yb=DataJPT;
% p1r=-yb(:,7)/100;
% p20r=yb(:,8);
% p4r=yb(:,9);
% p8r=yb(:,10);
% p12r=yb(:,11);
% p16r=yb(:,12);
% p40r=yb(:,13);
% 
% 
% eret=B(39,:)*PHI*x-(B(40,:)*x)+B(1,:)*x;
% 
% 
% [~,~,R,]=regress(p40r(2:end)-p40r(1:end-1)+p1r(1:end-1),[ones(179,1),-p40r(1:end-1)/40+p1r(1:end-1)]);
% fitTS=p40r(2:end)-p40r(1:end-1)+p1r(1:end-1) - R;
% 
% Y1a=-400*y(:,9)/4;
% Y2a=-400*y(:,10)/8;
% Y3a=-400*y(:,11)/12;
% Y4a=-400*y(:,12)/16;
% Y5a=-400*y(:,8)/20;
% Y10a=-400*y(:,8)/20;
% Y0a=-400*y(:,8)/20;
% 
% Y6a=-400*y(:,8)/20;
% CP = -12*Y6a + 10*Y5a + 16*Y4a - 12*Y3a - 4*Y2a + 2*Y1a;
% 
% [~,~,R,]=regress(39*p40r(93:end)/40-p40r(92:end-1)+p1r(92:end-1),[ones(88,1),CP(92:end-1)]);
% fitCP=39*p40r(93:end)/40-p40r(92:end-1)+p1r(92:end-1) - R;
% 
% %% figure 5
% [TP(93:end)' TS(93:end) CP(93:end) 400*eret(93:end)' 400*fitCP]
% 
% % plot(bsxfun(@plus,[eret(1:end-1)',fitCP],-mean([eret(1:end-1)',fitCP])));
% % plot(bsxfun(@plus,[eret(93:end-1)',fitCP(93:end)],-mean([eret(93:end-1)',fitCP(93:end)])));
% 
% 400*[eret(93:end)',fitCP]
% plot([1983:.25:2004.75]',[eret(93:end)',fitCP]);
% 400*[p40r(93:end)-p40r(92:end-1)+p1r(92:end-1) eret(93:end)',fitCP]
% 
% 
% 
