

%%% first, augment PHI to lagged output and investment

% L.y, L.i, D.c, D.y, D.i, slope, spread
% spread=400*(-y(:,9)/20+(B(20,:)*x(:,2:end))'/20);
    PHI=[PHI(1:end-1,1:end-1)
        zeros(7,NY-1)];
    PHI=[PHI zeros(NY+6,7)];
    PSI=[PSI(1:end-1,:); zeros(7,size(PSI,2))];
    
    PHI(end-6,1)=1;
    PHI(end-5,12)=1;
    
    % c, c_1, a
    PHI(end-4,:)=PHI(8,:); PHI(end-4,31)=PHI(end-4,31)-1; PHI(end-4,15)=PHI(end-4,15)+1;
    PHI(end-4,:)=[H(2,:) zeros(1,6)]*PHI;
    % y, a
    PHI(end-3,:)=PHI(1,:); PHI(end-3,33)=PHI(end-3,33)-1;PHI(end-3,15)=PHI(end-3,15)+1;
    PHI(end-3,:)=[H(1,:) zeros(1,6)]*PHI;
    %i, a
    PHI(end-2,:)=PHI(11,:); PHI(end-2,34)=PHI(end-2,34)-1;PHI(end-2,15)=PHI(end-2,15)+1;
    PHI(end-2,:)=[H(3,:) zeros(1,6)]*PHI;
    
    PHI(end-1,:)=[400*(-B(40,1:end-1)/40 + B(1,1:end-1)) zeros(1,7)];
    p13=0*PHI(1,:); p13(13)=1;
    PHI(end,:)=-400*[p13-[B(20,1:end-1) zeros(1,7)]]/20;
    
    
    PSI(end-4,:)=[H(2,:) zeros(1,6)]*PSI;
    PSI(end-3,:)=[H(1,:) zeros(1,6)]*PSI;
    PSI(end-2,:)=[H(3,:) zeros(1,6)]*PSI;
    PSI(end-1,:)=PHI(end-1,:)*PSI;
    PSI(end,:) = PHI(end,:)*PSI;
    
    NY=NY+6;
    
    PSI=PSI*SDX;
    
%% X = PHI*X(-1) + M*SDX*eps
%% VV = sum PHI^j*PSI*PSI'*PHI^j'
%% G_j = (PHI^j)* VV

%% vars, vars, shocks, frequencies
NF=500;
SS=zeros(NY,NY,9,NF);

for num=1:size(PSI,2)
    disp(num)
    SDX2=0*eye(length(SDX)); SDX2(num,num)=1;

    VV = PSI*SDX2*SDX2'*PSI';
    for i=1:200
        VV = VV + (PHI^i)*PSI*SDX2*SDX2'*PSI'*(PHI^i)';
    end


%         disp([H(3,:) zeros(1,6)]*VV*[H(3,:) zeros(1,6)]');
        S=0*repmat(PHI,[1,1,1,NF]);
        freq=linspace(2*pi/32,2*pi/6,NF)';
        freq=permute(freq,[2,3,4,1]);
        for i=1:100
            S = S + bsxfun(@times,( (PHI^i)*VV + VV'*(PHI^i)' ),cos(i*freq));
            zz=bsxfun(@times,( (PHI^i)*VV + VV'*(PHI^i)' ),cos(i*freq));
%             aa(i,:,num)=squeeze(zz(end-2,end-2,:,:))';
        end
        S=S+bsxfun(@times,VV,cos(0*freq));
        

        SS(:,:,num,:)=S;


end


%% SS is a variance matrix (d1, d2) for each shock (d3) at 100 different frequencies (d4)

SS2=sum(SS,4);
VD=zeros(NY,size(PSI,2));

for i=1:NY
    VD(i,:)=[squeeze(SS2(i,i,:)/sum(SS2(i,i,:)))]' ;
end

%% dc, dy, di, L, w, p, R, slope, spread, RB, Req
VDa=VD([end-3, end-4, end-2, 3, 5, 6, 9, end-1],:);


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% % this gets the importance of a given shock at a variety of frequencies
%% vars, vars, shocks, frequencies
NF=500;
SS=zeros(NY,NY,10,NF);

for num=1:size(PSI,2)
    disp(num)
    SDX2=0*eye(length(SDX)); SDX2(num,num)=1;

    VV = PSI*SDX2*SDX2'*PSI';
    for i=1:200
        VV = VV + (PHI^i)*PSI*SDX2*SDX2'*PSI'*(PHI^i)';
    end



        S=VV;
%         disp([H(3,:) zeros(1,6)]*VV*[H(3,:) zeros(1,6)]');
        S=0*repmat(S,[1,1,1,NF]);
        freq=linspace(0,pi,NF)';
        freq=permute(freq,[2,3,4,1]);
        for i=1:100
            S = S + bsxfun(@times,( (PHI^i)*VV + VV'*(PHI^i)' ),cos(i*freq));
            zz=bsxfun(@times,( (PHI^i)*VV + VV'*(PHI^i)' ),cos(i*freq));
%             aa(i,:,num)=squeeze(zz(end-2,end-2,:,:))';
        end
        S=S+bsxfun(@times,VV,cos(0*freq));
        

        SS(:,:,num,:)=S;


end

SS=squeeze(SS(end-4,end-4,:,:));
SS=bsxfun(@times,SS',1./sum(SS',2));

SS2=[SS(:,2) 1-SS(:,2)];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%simualte a sample
X=zeros(length(SS),100000);
X(:,1)=SS;
for i=2:100000
    X(:,i)=PHI*X(:,i-1) + PSI*SDX*randn(10,1);
end




    VV = PSI*SDX*SDX'*PSI';
    for i=1:2000
        VV = VV + (PHI^i)*PSI*SDX*SDX'*PSI'*(PHI^i)';
    end

cov(H(3,:)*X(:,11:end),H(end,:)*X(:,1:end-10))
ans(1,2)
H(3,:)*(PHI^10)*VV*H(end,:)'

for i=1:5
   CC(6+i)=H(3,:)*(PHI^i)*VV*H(end,:)';
   CC(i)=H(3,:)*VV*(PHI^i)'*H(end,:)';
end
   CC(6)=H(3,:)*VV*H(end,:)';
   

% 
% 
% 
