function theta = bounds4(param);

iotap=bound0B(param(1),.95);     
iotaw=bound0B(param(2),.95);     
h=bound01(param(3));  
Fbeta=(param(4)); % part of sd_pis
S=bound0(param(5));
fp=param(6); 
fy=param(7);       
fdy=param(8);      
rhoR=bound0B(param(9),.99);
rhoz=boundBB(param(10),.99);
rhog=bound0B(param(11),.99);
rhomiu=bound0B(param(12),.99);
rholambdap=bound0B(param(13),.99);
rholambdaw=bound0B(param(14),.99);
rhob=bound0B(param(15),.99);
rho_z=boundBB(param(16),.97);

sdR=bound0(param(17));
sdz=bound0(param(18)); 
sdg=bound0(param(19)); 
sdmiu=bound0(param(20));
sdlambdap=bound0(param(21)); 
sdlambdaw=bound0(param(22)); 
sdb=bound0(param(23));
sdPIS=bound0(param(24));
sdRRA=bound01(param(25));

ucons=bound01(param(26));
rs2=(param(27)); % part of sd_pis

ALPHA=bound0(param(28))+2;

sd_bond=(param(29));
Rcons=param(30);

rhoMAp=bound01(param(31));
rhoMAw=bound01(param(32));

rhomp=(param(33)); % part of sd_pis

theta = [iotap iotaw h Fbeta...
    S fp fy fdy rhoR rhoz rhog rhomiu rholambdap rholambdaw...
    rhob rho_z sdR sdz sdg sdmiu sdlambdap...
    sdlambdaw sdb sdPIS sdRRA ...
    ucons rs2 ALPHA sd_bond Rcons rhoMAp rhoMAw rhomp];

function rho = bound01(param);
rho = 1-1/(1+exp(param));

function rho = bound0B(param,B);
rho = B*[1-1/(1+exp(param))];

function rho = boundBB(param,B);
rho = B*[1-1/(1+exp(param))];
rho = 2*rho-B;

function sigma = bound0(param);
sigma = exp(param);