function CC_new=tester12(CC,GAM0,GAM1,C,PSI,PPI,SDX2)

RU=36;
UC=40;
a=15;
u=20;
p=6;
RRA_Z=23; 
CONS=length(GAM0);
c=8;
I=10;
Rkb=28;
NY=CONS;
RHO=.75;

coe_C=CC(1:3); coe_Z=CC(4:6);

GAM0(RU,RRA_Z)=coe_Z(1);
GAM0(RU,CONS)=coe_C(1);

GAM0(I,RRA_Z)=coe_Z(3);
GAM0(I,CONS)=coe_C(3);

GAM0(c,RRA_Z)=coe_Z(2);
GAM0(c,CONS)=coe_C(2);

[G1,C,impact,fmat,fwt,ywt,gev,eu]=gensys(GAM0,GAM1,C,PSI,PPI) ;

G_R = zeros(1,NY); G_R(RU)=1;
G_UC = zeros(1,NY); G_UC(UC)=1; G_UC(a)=-RHO;
G_u = zeros(1,NY); G_u(u)=1;

% wealth return
% -------------------------------------------------------------------------
coe_Z(1)=(1/2)*(G_UC+G_R)*impact*SDX2*...
    ((G_UC+G_R)*impact*SDX2)';

f_xp=zeros(1,NY); 
f_xp(Rkb)=1;

coe_Z(3)=(G_UC+G_R)*impact*SDX2*SDX2'*impact'*(-G_R+f_xp)';
coe_C(3)=(1/2)*(-G_R+f_xp)*impact*SDX2*SDX2'*impact'*(-G_R+f_xp)';

% Risk-free rate
% -------------------------------------------------------------------------    
f_xp=zeros(1,NY); 
f_xp(p)=-1;

coe_Z(2)=(G_UC+G_R)*impact*SDX2*SDX2'*impact'*(-G_R+f_xp)';
coe_C(2)=(1/2)*(-G_R+f_xp)*impact*SDX2*SDX2'*impact'*(-G_R+f_xp)'; 

% disp([(G_UC+G_R)*impact*SDX2;
%         (-G_R+f_xp)*impact*SDX2]);

CC_new=[coe_C coe_Z];
CC_new=CC_new(2:end);

if sum(eu)~=2;
    CC_new(1)=1000;
%     disp(eu')
end

